/*---------------------------------------------------------
PROGRAMA: cliente TAD ArvBin que escreve os itens em uma árvore binária
em pré-ordem.   Utiliza o TAD Pilha.
-----------------------------------------------------------*/

#include <stdio.h>
#include <stdlib.h>

typedef int ItemArv;
#include "arvBin.h"

typedef ArvBin ItemPilha;
#include "pilha.h"

/* ----------------------------------------------------- */
/* Escreve os itens armazenados na árvore em pré-ordem  */
void percorreEmPreOrdem( ArvBin p ){
  Pilha s;
  ArvBin nodo;

  criaPilha( &s );
  empilha( p, &s );
  while( !pilhaVazia( s )){
    desempilha( &s, &nodo );
    if( nodo != NULL ){
      printf( "%d\n", nodo->item );
      empilha( nodo->dir, &s );
      empilha( nodo->esq, &s );
    }
  }
}

/* ----------------------------------------------------- */
/* Programa: cria uma árvore binária e imprime a árvore em pré-ordem
*/
int main(int argc, char *argv[]){
  ArvBin arv;
  ItemArv v;
  
  criaArv( &arv );
  scanf( "%d", &v );
  while( v != 0 ){
    arv= insereArv( v, arv );
    scanf( "%d", &v );
  }
  printf( "\nArvore\n" );
  escreveArv( arv );

  percorreEmPreOrdem( arv );
  freeArv( arv );
  return 0;
}
